freeslot(
    "sfx_drpdsh",
    "S_DROPDASH1",
    "S_DROPDASH2",
    "S_DROPDASH3",
    "S_DROPDASH4",
    "S_DROPDASH5",
    "S_DROPDASH6"
)
sfxinfo[sfx_drpdsh].caption = "Drop Dash"

local dropskin = "juniosonic"

local DROPDASH_GRAVITY_BOOST = 5 * FRACUNIT / 4

addHook("PlayerThink", function(player)
    if player.dropcharging == nil then
        player.dropcharging = false
    end
end)

states[S_DROPDASH1] = {SPR_PLAY, SPR2_ROLL_1, 5, nil, 0, 0, S_DROPDASH2}
states[S_DROPDASH2] = {SPR_PLAY, SPR2_ROLL_2, 4, nil, 0, 0, S_DROPDASH3}
states[S_DROPDASH3] = {SPR_PLAY, SPR2_ROLL_3, 4, nil, 0, 0, S_DROPDASH4}
states[S_DROPDASH4] = {SPR_PLAY, SPR2_ROLL_4, 3, nil, 0, 0, S_DROPDASH5}
states[S_DROPDASH5] = {SPR_PLAY, SPR2_ROLL_1, 3, nil, 0, 0, S_DROPDASH6}
states[S_DROPDASH6] = {SPR_PLAY, SPR2_ROLL_2, 3, nil, 0, 0, S_DROPDASH1}

addHook("JumpSpinSpecial", function(player)
    if (player.mo.skin == dropskin)
    and (player.mo.state == S_PLAY_JUMP)
    and not (player.powers[pw_shield])
    and not (player.playerstate == PST_DEAD) then
        player.dropcharging = true
        S_StartSound(player.mo, sfx_drpdsh)
        player.mo.state = S_DROPDASH1
        return true
    end
	
end)

addHook("ShieldSpecial", function(player)
	if player.mo.skin == "juniosonic"
	and (player.powers[pw_shield] == SH_WHIRLWIND or player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_BUBBLEWRAP or player.powers[pw_shield] == SH_FORCE or player.powers[pw_shield] == SH_ATTRACT or player.powers[pw_shield] == SH_THUNDERCOIN or player.powers[pw_shield] == SH_FLAMEAURA or player.powers[pw_shield] == SH_ARMAGEDDON)
	and (player.cmd.buttons & BT_USE)
		player.dropcharging = false
	end
end)

addHook("PlayerThink", function(player)
    if player.dropcharging then
        -- Gestion de la gravité inversée
        if (player.mo.eflags & MFE_VERTICALFLIP) then
            -- Gravité inversée: on pousse vers le haut
            if player.mo.momz < 40*FRACUNIT then -- Limite supérieure
                player.mo.momz = $ + DROPDASH_GRAVITY_BOOST
            end
        else
            -- Gravité normale: on pousse vers le bas
            if player.mo.momz > -40*FRACUNIT then -- Limite inférieure
                player.mo.momz = $ - DROPDASH_GRAVITY_BOOST
            end
        end
        
        if not (player.cmd.buttons & BT_SPIN) then
            player.dropcharging = false
            player.mo.state = S_PLAY_JUMP
        end
    end
end)

addHook("PlayerThink", function(player)
    if (player.mo.skin == dropskin) then
        if player.dropcharging
        and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
        and not P_CheckDeathPitCollide(player.mo, true) then
            S_StartSound(player.mo, sfx_zoom)
            player.mo.state = S_PLAY_ROLL
            player.dropcharging = false
            player.pflags = $|PF_SPINNING
            P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT+player.speed)
            for i = 0, 6 do
                local mdust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_DUST)
                if mdust and mdust.valid then
                    P_InstaThrust(mdust, i*7*ANG30, -5*FRACUNIT)
                end
            end
        end
    end
end)

addHook("PlayerThink", function(p)
    if (p.mo.skin == dropskin) then
        if p.dropcharging
        and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
        or p.dropcharging
        and P_PlayerInPain(p)
        or p.dropcharging
        and (p.playerstate == PST_DEAD or P_CheckDeathPitCollide(p.mo, true)) then
            p.dropcharging = false
        end
    end
end)

addHook("PlayerThink", function(p)
    if (p.mo.skin == dropskin)
    and (p.pflags & PF_JUMPED) then
        p.pflags = $ & ~PF_SPINNING
    end
end)


addHook("MobjDeath", function(mo, inflictor, source)
    if not (mo and mo.valid) then return end
    if not (source and source.valid and source.player) then return end

    local player = source.player
	if mo.flags & MF_ENEMY then
		if player.dropcharging then
        -- Appliquer le boost de vitesse
        P_InstaThrust(player.mo, player.mo.angle, 16*FRACUNIT + player.speed)

        -- Propulser le joueur vers le haut
        player.mo.momz = 30*FRACUNIT

        -- Désactiver l'état de dropdash
        player.dropcharging = false
        player.mo.state = S_PLAY_ROLL
    end
	end
end)
