-- JUNIO RAIL EXIT BOOST SCRIPT
-- Donne un super boost à JunioSonic à la sortie d'une rail

local SKIN = "juniosonic"

addHook("ThinkFrame", function()
    for player in players.iterate
        local mo = player.mo
        if not mo or not player.valid then continue end
        if mo.skin ~= SKIN then continue end

        -- Initialisation custom
        if player.junio_wasgrinding == nil then
            player.junio_wasgrinding = false
        end

        -- Detecte si sur rail (GSgrind existe)
        local grinding = mo.GSgrind and mo.GSgrind.grinding

        -- Détection de sortie de rail
        if player.junio_wasgrinding and not grinding then
            -- On vient de sortir d'une rail !
            local railspeed = 0
            if mo.GSgrind and mo.GSgrind.railspeed then
                railspeed = abs(mo.GSgrind.railspeed)
            end
            -- On multiplie par 2 pour le boost
            player.junio_rail_boost = railspeed * 2
            player.junio_rail_boost_dir = mo.angle -- direction de sortie
            player.junio_rail_boost_pending = true
            -- Active Dash Mode instantané
            player.juniodashmode = 3*TICRATE
            player.juniodashmodeflag = true
            -- Option : On peut forcer une animation (facultatif)
            mo.state = S_PLAY_DASH
        end

        -- Application de la vitesse boostée quand on touche le sol
        if player.junio_rail_boost_pending and P_IsObjectOnGround(mo) then
            -- Applique le boost
            if player.junio_rail_boost and player.junio_rail_boost > 0 then
                mo.momx = FixedMul(player.junio_rail_boost, cos(player.junio_rail_boost_dir))
                mo.momy = FixedMul(player.junio_rail_boost, sin(player.junio_rail_boost_dir))
                -- Facultatif : On peut aussi booster jumpfactor ou normalspeed ici
                -- player.normalspeed = max(player.normalspeed, player.junio_rail_boost)
            end
            -- On supprime le flag pour éviter de réappliquer
            player.junio_rail_boost_pending = nil
            player.junio_rail_boost = nil
        end

        -- MAJ du statut grinding pour prochaine frame
        player.junio_wasgrinding = (grinding == true)
    end
end)
