local playerShields = {}

local function sp()
	if multiplayer then return false end
	if marathonmode then return false end
	if modeattacking then return false end
	if ultimatemode then return false end
	if not gamecomplete then return false end
	return true
end

addHook("PlayerThink", function(p)
    if not (p and p.mo and p.mo.valid) then return end
    
    local currentShield = p.powers[pw_shield]
    local storedShield = playerShields[p] or 0
    
    -- Enregistre uniquement quand un nouveau bouclier est obtenu
    if currentShield and currentShield ~= storedShield then
        -- Vérifie si c'est une amélioration (nouveau bouclier ou changement de type)
        if currentShield > 0 then
            playerShields[p] = currentShield
        end
    end
	
	if p.playerstate == PST_DEAD then
        playerShields[p] = 0
    end
	
	if p.exittimer and p.exittimer > 0 then
		playerShields[p] = currentShield
	end
end)

addHook("PlayerSpawn", function(p)
	if not (p and p.mo and p.mo.valid and (gametyperules & GTR_FRIENDLY)) then return end
	if p.mo.skin == "mario" or p.mo.skin == "skip" or p.mo.skin == "luigi" then return end
	
	local shield = playerShields[p] or 0

	if sp() and shield then
		p.powers[pw_shield] = shield
		P_SpawnShieldOrb(p)
	elseif shield == 14 or shield == 16 then
		local extraorb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_EXTRA_ORB)
		extraorb.target = p.mo
		P_SwitchShield(p, shield)
	else
		p.powers[pw_shield] = shield
		P_SpawnShieldOrb(p)
	end
end)

local monitors = {
	MT_FLAMEAURA_BOX,
	MT_SNEAKERS_BOX,
	MT_RING_BOX,
	MT_ATTRACT_BOX,
	MT_FORCE_BOX,
	MT_ARMAGEDDON_BOX,
	MT_WHIRLWIND_BOX,
	MT_ELEMENTAL_BOX,
	MT_INVULN_BOX,
	MT_1UP_BOX
}

addHook("MapLoad", function(map)
	if multiplayer then return end -- avoid desync for late joiners
	for k, v in pairs(monitors) do
		mobjinfo[v].height = 52 * FRACUNIT
	end
end)
